﻿Type=Class
Version=1.5
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public holder As Panel
	Private cvs, cvsBackground As Canvas
	Private DaysPanel As Panel
	Private month As Int
	Private boxW, boxH As Float
	Private ACTION_UP = 1, ACTION_MOVE = 2, ACTION_DOWN = 0 As Int
	Private tempSelectedDay As Int
	Private DaysPanelBackground As Panel
	Private dayOfWeekOffset As Int
	Private daysInMonth As Int
	Private tempSelectedColor As Int = Colors.Cyan
	Private selectedColor As Int = Colors.RGB(144, 176, 248)
	Private lblSelectedDay As Label
	Private selectedDate As Long
	Private targetButton As Button
	Private selectedYear, selectedMonth, selectedDay As Int
	Private Label1 As Label
	Private Label2 As Label
	Private Label3 As Label
	Private Label4 As Label
	Private Label5 As Label
	Private Label6 As Label
	Private Label7 As Label
	Private daysNames() As Label
	Private mTarget As Object
	Private mEventName As String
	Private monthsSheet As ActionSheet
	Private monthsNames As List
	Private yearsTimer As Timer
	
	Private btnYears As Button
	Private btnMonths As Button
	Private stpYears As Stepper
	Private Base As Panel
End Sub

'Initializes the picker
Public Sub Initialize (target As Object, EventName As String)
	mTarget = target
	mEventName = EventName
End Sub

Public Sub AddToParent(ACT As Panel, btn As Button)
	holder.Initialize("holder")
	holder.Visible = False
	holder.Color = Colors.Transparent
	ACT.AddView(holder, 0, 0, 100%x, 100%y)
	holder.LoadLayout("DatePicker")
	daysNames = Array As Label(Label1, Label2, Label3, Label4, Label5, Label6, Label7)
	boxW = DaysPanel.Width / 7
	boxH =  DaysPanel.Height / 6
	Dim i As Int
	For i = 0 To daysNames.Length - 1
		daysNames(i).Left = boxW * i + 3dip
	Next
	cvs.Initialize(DaysPanel)
	cvsBackground.Initialize(DaysPanelBackground)
	month = DateTime.GetMonth(DateTime.Now)
	stpYears.Value = DateTime.GetYear(DateTime.Now)
	stpYears.Alpha = 0
	monthsNames = DateUtils.GetMonthsNames
	monthsSheet.Initialize("monthsSheet", "", "", "", monthsNames)
	i = 0
	For Each D As String In DateUtils.GetDaysNames
		daysNames(i).Text = D.SubString2(0, 2)
		i = i + 1
	Next
	targetButton = btn
	SetDate(DateTime.Now, False)
	lblSelectedDay.Visible = False
	DrawDays
	yearsTimer.Initialize("YearsTimer", 5000) 'hide the years stepper after x seconds
End Sub

'Returns the selected date.
Public Sub GetDate As Long
	Return selectedDate
End Sub
'Sets the selected date.
'UpdateLabel - Whether to update the label text.
Public Sub SetDate(date As Long, UpdateLabel As Boolean)
	stpYears.Value = DateTime.GetYear(date)
	month = DateTime.GetMonth(date)
	SelectDay(DateTime.GetDayOfMonth(date), UpdateLabel)
	UpdateYearButton
	btnMonths.Text = monthsNames.Get(month - 1)
End Sub
Private Sub SelectDay(day As Int, UpdateButton As Boolean)
	selectedDate = DateUtils.SetDate(stpYears.Value, month, day)
	selectedDay = day
	selectedMonth = month
	selectedYear = stpYears.Value
	If UpdateButton AND targetButton.IsInitialized AND targetButton Is Button Then targetButton.Text = DateTime.Date(selectedDate)
End Sub

Private Sub UpdateYearButton
	btnYears.Text = NumberFormat2(stpYears.Value, 0, 0, 0, False)
End Sub
'Shows the picker.
Public Sub Show
	holder.Visible = True
	holder.Alpha = 0
	holder.SetAlphaAnimated(500, 1)
	holder.SetParallaxEffect(30, 0)
	DrawDays
End Sub

Sub btnMonths_Click
	monthsSheet.Show(holder)
End Sub

Sub monthsSheet_Click (Item As String)
	month = monthsNames.IndexOf(Item) + 1
	btnMonths.Text = Item
	DrawDays
End Sub
Sub btnYears_Click
	If yearsTimer.Enabled = True Then
		YearsTimer_Tick
	Else
		stpYears.SetAlphaAnimated(500, 1)
		yearsTimer.Enabled = True
	End If
	
End Sub
Sub stpYears_ValueChanged (Value As Double)
	UpdateYearButton
	yearsTimer.Enabled = False
	yearsTimer.Enabled = True
	DrawDays
End Sub
Sub YearsTimer_Tick
	stpYears.SetAlphaAnimated(200, 0)
	yearsTimer.Enabled = False
End Sub

Private Sub DrawDays
	cvsBackground.DrawColor(Colors.Transparent)
	cvs.DrawColor(Colors.Transparent)
	Dim firstDay As Long = DateUtils.SetDate(stpYears.Value, month, 1) - 1
	dayOfWeekOffset = DateTime.GetDayOfWeek(firstDay) Mod 7
	daysInMonth = DateUtils.NumberOfDaysInMonth(month, stpYears.Value)
	If stpYears.Value = selectedYear AND month = selectedMonth Then
		'draw the selected box
		DrawBox(cvs, selectedColor, (selectedDay - 1 + dayOfWeekOffset) Mod 7, _
			(selectedDay - 1 + dayOfWeekOffset) / 7)
	End If
	For day = 1 To daysInMonth
		Dim row As Int = (day - 1 + dayOfWeekOffset) / 7
		cvs.DrawText(day, (((dayOfWeekOffset + day - 1) Mod 7) + 0.5) * boxW, _
			(row + 0.75)* boxH, Label1.Font, Colors.Black, "CENTER")
	Next
	cvs.Refresh
	cvsBackground.Refresh
End Sub

Private Sub DrawBox(c As Canvas, clr As Int, x As Int, y As Int)
	Dim r As Rect
	r.Initialize(x * boxW, y * boxH, (x + 1) * boxW, (y + 1) * boxH)
	c.DrawRectRounded(r, clr, True, 0, 5)
End Sub

Private Sub DaysPanel_Touch (ACTION As Int, X As Float, Y As Float)
	Dim boxX = X / boxW, boxY = Y / boxH As Int
	Dim newSelectedDay As Int = boxY * 7 + boxX + 1 - dayOfWeekOffset
	Dim validDay As Boolean = newSelectedDay > 0 AND newSelectedDay <= daysInMonth
	If yearsTimer.Enabled Then YearsTimer_Tick
	If ACTION = ACTION_DOWN OR ACTION = ACTION_MOVE Then
		If newSelectedDay = tempSelectedDay Then Return
		cvsBackground.DrawColor(Colors.Transparent) 'clear background
		tempSelectedDay = newSelectedDay
		If validDay Then
			DrawBox(cvsBackground, tempSelectedColor, boxX, boxY)
			lblSelectedDay.Text = newSelectedDay
			lblSelectedDay.Visible = True
		Else
			lblSelectedDay.Visible = False
		End If
	Else If ACTION = ACTION_UP Then
		lblSelectedDay.Visible = False
		cvsBackground.DrawColor(Colors.Transparent)
		If validDay Then
			SelectDay(newSelectedDay, True)
			CallSub3(mTarget, mEventName & "_Closed", False, GetDate)
			Hide
		End If
	End If
	cvsBackground.Refresh
End Sub
Public Sub btnCancel_Click
	CallSub3(mTarget, mEventName & "_Closed", True, GetDate)
	Hide
End Sub
Private Sub btnToday_Click
	SetDate(DateTime.Now, True)
	CallSub3(mTarget, mEventName & "_Closed", False, GetDate)
	Hide
End Sub

Public Sub IsVisible As Boolean
	Return holder.Visible
End Sub
Private Sub holder_Click
	btnCancel_Click
End Sub
'Hides the picker.
Public Sub Hide
	holder.SetAlphaAnimated(200, 0)
End Sub
